/* Infix notation calculator. */ 
%{ 
%}

%token NUM 
%left '-' '+' 
%left '*' '/' 
%left NEG 
%right '^' /* exponentiation */
 
%%
input:
	exp					{ trace( $1 ); }
	;

exp:
	 NUM 				{ $$ = $1; }
	| exp '+' exp 		{ $$ = $1 + $3; } 
	| exp '-' exp 		{ $$ = $1 - $3; }
	| exp '*' exp 		{ $$ = $1 * $3; } 
	| exp '/' exp 		{ $$ = $1 / $3; } 
	| '-' exp %prec NEG { $$ = -$2; } 
	| exp '^' exp 		{ $$ = Math.pow( $1, $3 ); } 
	| '(' exp ')' 		{ $$ = $2; } 
	;
%%